var NewTabButton = {
	ltnManager: null,
	tabmail: document.getElementById("tabmail"),
	
	getCurrentTabMode: function() {
		var type = null;
		//if (tabmail && tabmail.tabContainer.selectedItem) {
		if (this.tabmail && this.tabmail.tabContainer.selectedIndex >= 0) {
			var tab = this.tabmail.tabInfo[this.tabmail.tabContainer.selectedIndex];
			type = tab.mode.type;
			//if (type == "glodaSearch" && (tab.query || tab.searcher || tab.collection)) {
			if (type == "glodaSearch" && tab.collection) { //distinguish gloda search result
				type = "glodaSearch-result";				
			}
		}
		
		return type;
	},
	
	openMessagesInNewTabsButton: function(event, notOpenFolder)	{
		if (window.document.documentElement.getAttribute("windowtype") != "mail:3pane") return;
		//if ( event && event.originalTarget.localName != "toolbarbutton") return;
		var mode = this.getCurrentTabMode(); 
		if ( mode != "folder" && mode != "glodaSearch") return;
		
		var focusedPane = WhichPaneHasFocus();
		var func = null;
		var isFolder = false;
 		var that = this;
		var openInBackground = nsPreferences.getBoolPref("mail.tabs.loadInBackground", true);
	  if (event.shiftKey) openInBackground = !openInBackground;

	  if (!notOpenFolder && focusedPane && focusedPane.getAttribute("id") == "folderTree") {
			func = function() {
				//MsgOpenNewTabForFolder(null,-1);
				MsgOpenNewTabForFolder(openInBackground);
			};
			isFolder = true;
		} else if (gDBView) {
			var selectedMessages = gFolderDisplay.selectedMessages;
  		if (selectedMessages.length) {
		 		func = function() {
		 			that.saveCurrentLtnTodayPaneStatus();
		 			if (selectedMessages.length === 1) {
		 				//ThreadTreeContextMenuNewTab(event); //TB3b3
		 				OpenMessageInNewTab(event);
		 			} else {
  					var numMessages = selectedMessages.length;
				    for (var i = 0; i < numMessages; i++) {
      				that.tabmail.openTab("message", {msgHdr: selectedMessages[i],
          			viewWrapperToClone: gFolderDisplay.view,
          			background: (i !== numMessages - 1) || openInBackground});
				    }
	 					//MsgOpenSelectedMessages(); //TB's original		 					
		 			}
		 		}
		  }	
		}
	
		if (func) {
			setTimeout(func);
		}
	},
	
	openMessageInNewTabByHdrDoubleClick: function(event) {
		if (window.document.documentElement.getAttribute("windowtype") != "mail:3pane") return;
		//if (mailTabType.folderAndThreadPaneVisible) {
		if (this.getCurrentTabMode() === "folder") {
			this.openMessagesInNewTabsButton(event, true);
		} else {
      this.tabmail.removeCurrentTab();
		}
	
	},
	
	saveCurrentLtnTodayPaneStatus: function() {
		this.ltnManager.saveCurrentLtnTodayPaneStatus();	
	},
	
	onLoadNewTabButton: function() {
		var that = this;
		this.ltnManager = NewTabButtonLtnManager;
		this.ltnManager.init(this);
		
		//window.ThreadPaneDoubleClick = this.ThreadPaneDoubleClick
		if (nsPreferences.getBoolPref("opentab.hdr_double_click_open", false)) {
			var hdrView = document.getElementById("msgHeaderView");
			hdrView.setAttribute("ondblclick","NewTabButton.openMessageInNewTabByHdrDoubleClick(event)");
		}
		
		var tpcxt = document.getElementById("threadPaneContext-openNewTab");
		if (tpcxt) {
			var cmd = tpcxt.getAttribute("oncommand");
			cmd = "NewTabButton.saveCurrentLtnTodayPaneStatus();"+cmd;
			tpcxt.setAttribute("oncommand", cmd);
			//tpcxt.addEventListener("command", saveCurrentLtnTodayPaneStatus, true);
		}
		
		var monitor = {
			onTabTitleChanged: function(aTab){},
			onTabSwitched: function(aTab, aOldTab){
				var broadcaster = document.getElementById("OpenTab:OpenEnable");
				var mode = that.getCurrentTabMode();
				if (mode == "folder" || mode == "glodaSearch") {
					broadcaster.removeAttribute("collapsed");
				} else { //mode == "message"
					broadcaster.setAttribute("collapsed", true);
				}
				that.ltnManager.toggleLtnTodayPane();
			}
		};
	  this.tabmail.registerTabMonitor(monitor);
	  
	  //hide tabbar button
	  if (!nsPreferences.getBoolPref("opentab.tabbar_button", true)) {
	  	document.getElementById("button-opentab-tabbar").setAttribute("hidden", true);
	  }
	  
	  //hide header view button
	  /*
	  if (!nsPreferences.getBoolPref("opentab.hdr_button", true) || !this.tabmail) {
	  	document.getElementById("hdrNewTabButton").setAttribute("hidden", true);
	  }
	  */ 
	}
};

var NewTabButtonLtnManager = {
	ltnCollapsed: null, //null or true or false
	ltnTodaySplit: null,
	owner: null,
	
	init: function(owner) {
		this.owner = owner;
		this.ltnCollapsed = null,
		this.ltnTodaySplit = document.getElementById("today-splitter");
	},
	
	toggleLtnTodayPane: function() {
		if (this.ltnCollapsed === null) return;
		
		if (!this.ltnTodaySplit) return;
		if (this.getCurrentTabMode() != "message") {
			if (this.ltnCollapsed) this.ltnTodaySplit.setAttribute("state", "collapsed");		
			else this.ltnTodaySplit.removeAttribute("state");
		} else {
			this.ltnTodaySplit.setAttribute("state", "collapsed");		
		}
	},
	
	getCurrentTabMode: function() {
		return this.owner.getCurrentTabMode();
	},
	
	saveCurrentLtnTodayPaneStatus: function() {
 		this.ltnCollapsed = null;
		var collapseLtn = nsPreferences.getBoolPref("opentab.collapse_ltn", true);
 		if (collapseLtn) {
			if (this.ltnTodaySplit) {
				this.ltnCollapsed = this.ltnTodaySplit.getAttribute("state") == "collapsed";
			}
		}		
	}
};

//init
function onLoadNewTabButton()
{
	NewTabButton.onLoadNewTabButton();
}

window.addEventListener("load", onLoadNewTabButton, false);
