var gOTBSetting;

function initOTBSetting()
{
	gOTBSetting = new OTBSetting();
	gOTBSetting.onLoad();
}

//class PSWSettings
function OTBSetting()
{
	this.elementIDs = [
		"OTBHdrDblClk",
		"OTBHideLtn",
		"OTBOpenBackground",
		"OTBTabAutoHide",
		"OTBTabbarButton"
		//"OTBHdrButton"
		];
	this.pref = Components.classes["@mozilla.org/preferences-service;1"]
	  .getService(Components.interfaces.nsIPrefBranch);
}

OTBSetting.prototype.savePrefs = function()
{
	for( var i = 0; i < this.elementIDs.length; i++ ) {
		var elementID = this.elementIDs[i];
		var element = document.getElementById(elementID);
		if (!element) break;
		var eltType = element.localName;
		if (eltType == "radiogroup")
		  this.pref.setIntPref(element.getAttribute("prefstring"), parseInt(element.value));
		else if (eltType == "checkbox")
		  this.pref.setBoolPref(element.getAttribute("prefstring"), element.checked);
		else if (eltType == "textbox" && element.preftype == "int")
		  this.pref.setIntPref(element.getAttribute("prefstring"), parseInt(element.getAttribute("value")) );
		else if (eltType == "textbox")
		  nsPreferences.setUnicharPref(element.getAttribute("prefstring"), element.value);
	  else if (eltType == "menulist" && element.getAttribute("preftype") == "string")
	  	this.pref.setCharPref(element.getAttribute("prefstring"), element.value);
		else if (eltType == "menulist")
	  	this.pref.setIntPref(element.getAttribute("prefstring"), parseInt(element.value));
	}

	return true;
}

OTBSetting.prototype.cancelPrefs = function()
{
	return true;
}

OTBSetting.prototype.onLoad = function()
{
	// initialize the default window values...
	for( var i = 0; i < this.elementIDs.length; i++ ) {
		var elementID = this.elementIDs[i];
		var element = document.getElementById(elementID);
		if (!element) break;
		var eltType = element.localName;

		if (eltType == "radiogroup") {
			try {
				element.selectedItem = element.childNodes[this.pref.getIntPref(element.getAttribute("prefstring"))];
			} catch(e) {
				element.selectedItem = element.childNodes[element.getAttribute("defaultpref")];
				try {
					this.pref.setIntPref( element.getAttribute("prefstring"), element.getAttribute("defaultpref") );
				} catch (e) {}
			}
		} else if (eltType == "checkbox") {
			try {
				element.checked = ( this.pref.getBoolPref(element.getAttribute("prefstring")) == true );
			} catch(e) {
				element.checked = ( element.getAttribute("defaultpref") == "true" );
				try {
					this.pref.setBoolPref( element.getAttribute("prefstring"), element.checked );
				} catch(e){}
			}
		} else if (eltType == "textbox") {
			var str = nsPreferences.copyUnicharPref(element.getAttribute("prefstring"),"");
			if (str) element.setAttribute("value", str);
		} else if (eltType == "menulist" && element.getAttribute("preftype") == "string") {
			try {
				element.value = this.pref.getCharPref(element.getAttribute("prefstring"));
			} catch(e) {
				element.value = element.getAttribute("defaultpref");
				try {
					this.pref.setCharPref( element.getAttribute("prefstring"), element.value);
				} catch (e) {}
			}			
		} else if (eltType == "menulist") {
			try {
				element.value = this.pref.getIntPref(element.getAttribute("prefstring")).toString();
			} catch(e) {
				element.value = element.getAttribute("defaultpref");
				try {
					this.pref.setIntPref( element.getAttribute("prefstring"), parseInt(element.value) );
				} catch (e) {}
			}
		}
	}
}

